<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_component_template".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectoryComponentTemplate".
 *
 * Columns in table "directory_component_template" available as properties of the model,
 * followed by relations of table "directory_component_template" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $description
 * @property string $layout_components
 * @property integer $component_section_id
 * @property string $style_variables
 * @property string $texts_and_placeholders
 *
 * @property DirectoryComponentSection $componentSection
 */
abstract class BaseDirectoryComponentTemplate extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_component_template';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectoryComponentTemplate|DirectoryComponentTemplates', $n);
    }

    public static function representingColumn()
    {
        return 'layout_components';
    }

    public function rules()
    {
        return array(
            array('layout_components, component_section_id', 'required'),
            array('component_section_id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>50),
            array('description', 'length', 'max'=>255),
            array('style_variables, texts_and_placeholders', 'safe'),
            array('name, description, style_variables, texts_and_placeholders', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, description, layout_components, component_section_id, style_variables, texts_and_placeholders', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'componentSection' => array(self::BELONGS_TO, 'DirectoryComponentSection', 'component_section_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'description' => Yii::t('app', 'Description'),
            'layout_components' => Yii::t('app', 'Layout Components'),
            'component_section_id' => null,
            'style_variables' => Yii::t('app', 'Style Variables'),
            'texts_and_placeholders' => Yii::t('app', 'Texts And Placeholders'),
            'componentSection' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('layout_components', $this->layout_components, true);
        $criteria->compare('component_section_id', $this->component_section_id);
        $criteria->compare('style_variables', $this->style_variables, true);
        $criteria->compare('texts_and_placeholders', $this->texts_and_placeholders, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
